搜索

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.

— It is a matter of security to change such things every now and then, to keep the enemy in the dark.

— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!

— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.

— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!

— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.

— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.

— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.

— Hmm, in that case I need a computer program to minimize the cost. You don’t know some very cheap software gurus, do you?

— In fact, I do. You see, there is this programming contest going on… Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.

1033
1733
3733
3739
3779
8779
8179The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.InputOne line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).OutputOne line for each case, either with a number stating the minimal cost or containing the word Impossible.
Sample Input3
1033 8179
1373 8017
1033 1033
Sample Output
6
7
0
这道题的意思是从A变成B,但是中间的变换得是素数,运用了素数打表由于给定的就是一个四位数,把这四个数进行分离。

#include<stdio.h>
#include<string.h>
#include<queue>
#include<algorithm>
using namespace std;
int dis[10111],book[10111],n,m;
struct ha
{
    int x,s;
}p,q;
void w()
{
    memset(dis,0,sizeof(dis));
    dis[1]=1;
    for(int i=2;i<10111;i++)
    {
        if(!dis[i])
        {
            for(int j=i*2;j<10111;j=j+i)
                dis[j]=1;
        }
    }
}
int dfs(int a,int b)
{
    int num;
    queue<ha>Q;
    p.x=a;
    p.s=0;
    Q.push(p);
    while(!Q.empty())
    {
        p=Q.front();
        Q.pop();
        if(p.x==b)
            return p.s;
        int to[5];
        to[1]=p.x/1000;
        to[2]=p.x/100%10;
        to[3]=p.x/10%10;
        to[4]=p.x%10;
        for(int i=1;i<=4;i++)
        {
            int t=to[i];
            for(int j=0;j<10;j++)
            {
                if(to[i]!=j)
                {
                    to[i]=j;
                    num=to[1]*1000+to[2]*100+to[3]*10+to[4];
                }
                if(num>=1000&&num<=9999&&book[num]==0&&dis[num]==0)
                {
                    q.x=num;
                    q.s=p.s+1;
                    Q.push(q);
                    book[num]=1;
                }
            }
            to[i]=t;
        }
    }
    return -10;
}
int main()
{
    int t;
    w();
    scanf("%d",&t);
    w();
    while(t--)
    {
        scanf("%d%d",&n,&m);
        memset(book,0,sizeof(book));
        int sum=dfs(n,m);
        if(sum!=-10)
            printf("%d\n",sum);
        else
            printf("Impossible\n");
    }
    return 0;
}
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值